import org.xml.sax.*;
import org.xml.sax.ext.DeclHandler;
import org.apache.xerces.parsers.SAXParser;
import org.xml.sax.helpers.DefaultHandler;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import javax.swing.text.*;
import java.awt.*;
import java.awt.event.*;
/**
 * Permet de faire la lecture d'un document sauvegarder au format XML
 *  @author Gros Pierre Emmanuel
 *         <a href="mailto:gros@limsi.fr">gros@limsi.fr</a>
 * @version 6.0
 */
public class DefaultHandlerLoadXml  extends DefaultHandler implements DocumentBaliseName
{
private static final String
        DEFAULT_PARSER_NAME = "org.apache.xerces.parsers.SAXParser";

private Balise _balise;
private ListeBalise liste_balise;
private ListeTag _liste_tag;
private Tag _tag;
private String _dtdfilename;
private String _text;
private Vector _listeattribut;
private Object _variable;
private AttributDecl attribut_declaration;
private Vector enumeration_attribut;
private SimpleAttributeSet attribut_balise;
private Tag tag;
private String _document;
private boolean is_text;
/**
 * renvoie la chaine de caractere du document texte
 * @result le document texte
 */
public String getDocument(){return _document;}
/**
 * renvoie la liste des balise lut dans le fichier
 * @result la liste des balise
 */
public ListeBalise getListeBalise(){return liste_balise;}
/**
 * renvoie la liste des tag lut dans le fichier
 * @result la liste des tags
 */
public ListeTag getListeTag(){return _liste_tag;}
/**
 * renvoie le nom du fichier dtd
 * @result le nom du fichier
 */
public String getDtdFileName(){return _dtdfilename;}
/**
 * hook appele lors du debut de lecture du document
 */
public void startDocument() 
{
is_text=false;
_document=new String();
}
/**
 * appele lors de la lecture du nom du fichier DTD
 * @param attr attribut de l'element XML
 */
public void lectDTD(Attributes attr)
{
_dtdfilename=new String(attr.getValue(attribut_name));
}
Balise createBalise(Attributes attr)
{
String name_balise=attr.getValue(balise_name);
boolean _empty=attr.getValue(empty).equals("true");
int _order=Integer.parseInt(attr.getValue(order));
Balise result=new Balise(name_balise,_empty);
result.setOrder(_order);
return result;

}
public Tag createTag(Attributes attr)
{
int numero_balise=Integer.parseInt(attr.getValue(nb_balise));
System.err.println("toc1");
int debut_ligne=Integer.parseInt(attr.getValue(debut));
System.err.println("toc2");
int fin_ligne=Integer.parseInt(attr.getValue(fin));
System.err.println("toc3");
boolean isdead_att=attr.getValue(isdead).equals("true");
System.err.println("toc4");
int nb_ligne=Integer.parseInt(attr.getValue(ligne));
System.err.println("toc5");
int _order=Integer.parseInt(attr.getValue(nb_balise));
System.err.println("toc6");
Balise b=liste_balise.getBaliseByOrder(_order);
return (new Tag(b,debut_ligne,fin_ligne, nb_ligne));
}
void createAttribut(Attributes attr)
{
_tag.setValue(attr.getValue(attribut_name),attr.getValue(attribut_value));


}
SimpleAttributeSet createAttributStyleBalise(Attributes att)
{
SimpleAttributeSet result=new SimpleAttributeSet();
StyleConstants.setFontSize(result,Integer.parseInt(att.getValue(fontsize)));
int red_back=Integer.parseInt(att.getValue(backcolor_red));
int green_back=Integer.parseInt(att.getValue(backcolor_green));
int blue_back=Integer.parseInt(att.getValue(backcolor_blue));
Color back=new Color(red_back,green_back,blue_back);
StyleConstants.setBackground(result, back) ;
int red_front=Integer.parseInt(att.getValue(frontcolor_red));
int green_front=Integer.parseInt(att.getValue(frontcolor_green));
int blue_front=Integer.parseInt(att.getValue(frontcolor_blue));
Color front=new Color(red_front,green_front,blue_front);
StyleConstants.setForeground(result,front) ;
String fontfamily=att.getValue(font);
StyleConstants.setFontFamily(result,fontfamily);
StyleConstants.setUnderline(result,att.getValue(underline).equals("true"));
StyleConstants.setBold(result,att.getValue(bold).equals("true"));
StyleConstants.setStrikeThrough(result,att.getValue(strike).equals("true"));
StyleConstants.setItalic(result,att.getValue(italic).equals("true"));
return result;
}


AttributDecl createAttributBalise(Attributes attr)
{
String attribut_name=attr.getValue(attribut_balise_name);
int type=Integer.parseInt(attr.getValue(attribut_balise_type));
String tmp=attr.getValue(attribut_balise_default);
String _default=(tmp.equals("null"))?null:tmp;
String _valeur=attr.getValue(attribut_balise_valeur);
boolean _enum=attr.getValue(attribut_enum).equals("true");
if (!_enum)
{
return (new AttributDecl(attribut_name,type,_default,_valeur,"titi"));
}
else 
return (new AttributDecl(attribut_name,type,_default,_valeur,"titi",null));

}
void AddValue(Attributes attr)
{
enumeration_attribut.add(attr.getValue(attribut_value));
}
public void startElement(java.lang.String uri, java.lang.String localName, java.lang.String qName, Attributes attributes) 
{
System.err.println("Element uri:"+uri+" localName:"+localName+" qName:"+qName);
if (localName.equals(attribut_def))
{/** un attribut des tags**/
	createAttribut(attributes);
}else
if (localName.equals(style_def))
{/** style d une balise **/
	attribut_balise=createAttributStyleBalise(attributes);
}else 
if (localName.equals(balise_def))
{/** definition de la balise **/
	_balise=createBalise(attributes);
}
else 
if (localName.equals(liste_balise_def))
{/** definition de la liste de balise **/
liste_balise=new ListeBalise();
}
else 
if (localName.equals(tag_def))
{
_tag=createTag(attributes);
}
else 
if (localName.equals(liste_tag))
{
_liste_tag=new ListeTag();
}
else
if (localName.equals(attribut_balise_def))
{
attribut_declaration=createAttributBalise(attributes);
_balise.Add(attribut_declaration);
}
else 
if (localName.equals(attribut_enum))
{
enumeration_attribut=new Vector();
}else
if (localName.equals(value_liste))
{
AddValue(attributes);
}else if (localName.equals(dtdfilename))
{
lectDTD(attributes);
}
else if (localName.equals("text")) {
	System.err.println("is_text");
	is_text=true;
	
	}
}
public void endElement(java.lang.String namespaceURI, java.lang.String localName, java.lang.String qName) 
{
if (localName.equals(balise_def))
{
_balise.UpDateAttribut(attribut_balise);
liste_balise.add(_balise);
}else
if (localName.equals(tag_def))
{
_liste_tag.add(_tag);
}else
if (localName.equals(attribut_balise_def))
{
if (attribut_declaration.getEnum()) attribut_declaration.setValueListe(enumeration_attribut);
//_balise.Add(attribut_declaration);
}
}
           
public void characters(char[] ch, int start, int length) 
{System.err.println("DOCUMENT:"+_document);
if (is_text) _document=new String(_document+new String(ch,start,length));
System.err.println("DOCUMENT:"+_document);
}
public DefaultHandlerLoadXml()
{

}
public void lect(FileReader f) throws Exception
{
  SAXParser  parser = (SAXParser)Class.forName(DEFAULT_PARSER_NAME).newInstance();
  
parser.setContentHandler (this);
     parser.parse(new InputSource(f));
    
} 
public static void main(String args[]) 
{
 try{ SAXParser  parser = (SAXParser)Class.forName(DEFAULT_PARSER_NAME).newInstance();
  DefaultHandler lo = new DefaultHandlerLoadXml();
parser.setContentHandler (lo);
     parser.parse(new InputSource(new FileReader(args[0])));
    }catch (Exception q) {System.err.println(q);}
     
}
           
}
           